/**
 * Transforms an object schema containing arrays to an array schema containing objects.
 *
 * uischema = {"ui:options": {
 *  uiSchema: <uiSchema> (uiSchema which is passed to array items)
 * }
 */
export default class ArrayCombinerField extends React.Component<any, any, any> {
    static propTypes: {
        uiSchema: PropTypes.Validator<PropTypes.InferProps<{
            "ui:options": PropTypes.Requireable<PropTypes.InferProps<{
                additionalItemsAmount: PropTypes.Requireable<number>;
            }>>;
            uiSchema: PropTypes.Requireable<object>;
        }>>;
        schema: PropTypes.Validator<PropTypes.InferProps<{
            type: PropTypes.Requireable<string>;
        }>>;
        formData: PropTypes.Validator<object>;
    };
    static getName(): string;
    constructor(props: any);
    constructor(props: any, context: any);
    getStateFromProps(props: any): {
        schema: {
            type: string;
        };
        errorSchema: any;
        formData: any;
        uiSchema: any;
        onChange: (formData: any) => void;
    };
    onChange: (formData: any) => void;
}
import * as React from "react";
import * as PropTypes from "prop-types";
