"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const VirtualSchemaField_1 = require("../VirtualSchemaField");
const utils_1 = require("../../utils");
let AutoArrayField = class AutoArrayField extends React.Component {
    constructor() {
        super(...arguments);
        this.onChange = (formData) => {
            const emptyItem = utils_1.getDefaultFormState(this.props.schema.items);
            if (formData && formData.length !== 0 && this.props.formContext.utils.formDataEquals(formData[formData.length - 1], emptyItem, this.props.idSchema.$id)) {
                formData = formData.slice(0, formData.length - 1);
            }
            this.props.onChange(formData);
        };
    }
    static getName() { return "AutoArrayField"; }
    getStateFromProps(props) {
        const { formData = [], schema, uiSchema, formContext: { utils } } = props;
        const state = { formData, onChange: this.onChange };
        const newEmptyItem = utils_1.getDefaultFormState(schema.items);
        const emptyItem = this.emptyItem
            && utils.formDataEquals(newEmptyItem, this.emptyItem, props.idSchema.$id)
            && formData.every(item => utils_1.getUUID(item) !== utils_1.getUUID(this.emptyItem))
            ? this.emptyItem
            : utils_1.assignUUID(newEmptyItem);
        this.emptyItem = emptyItem;
        if (formData && (formData.length === 0 || !utils.formDataEquals(formData[formData.length - 1], emptyItem, props.idSchema.$id))) {
            state.formData = [...formData, emptyItem];
        }
        state.uiSchema = Object.assign(Object.assign({}, uiSchema), { "ui:options": Object.assign(Object.assign({ canAdd: false }, (uiSchema["ui:options"] || {})), { nonOrderables: [state.formData.length - 1], nonRemovables: [state.formData.length - 1] }) });
        return state;
    }
};
AutoArrayField.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            autofocus: PropTypes.boolean
        })
    }),
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["array"])
    }).isRequired,
    formData: PropTypes.array
};
AutoArrayField = __decorate([
    VirtualSchemaField_1.default
], AutoArrayField);
exports.default = AutoArrayField;
