/**
 * Changes formData on onChange event according to conditional rules.
 * uiSchema = {
 *   "ui:options": {
 *     rules: { // Can also be an array of rules
 *       transformations: {
 *        <field name to change if conditions met>: <new value>
 *       },
 *       conditions: {
 *         <conditional field name>: { // Note that regexp and length must both pass for this rule to pass.
 *           regexp: <string> <if the conditional field value matches this regexp, this condition will pass>
 *           length: <number> <if the conditional field value length is equal or more, this conndition will pass>
 *           reverse: <boolean> <Reverses the passing value>
 *         }
 *       }
 *     }
 *   }
 * }
 */
export default class ConditionalOnChangeField extends React.Component<any, any, any> {
    static propTypes: {
        uiSchema: PropTypes.Validator<PropTypes.InferProps<{
            "ui:options": PropTypes.Validator<PropTypes.InferProps<{
                rules: PropTypes.Validator<PropTypes.InferProps<PropTypes.ValidationMap<any>> | PropTypes.InferProps<PropTypes.ValidationMap<any>>[]>;
            }>>;
            uiSchema: PropTypes.Requireable<object>;
        }>>;
        schema: PropTypes.Validator<PropTypes.InferProps<{
            type: PropTypes.Requireable<string>;
        }>>;
        formData: PropTypes.Validator<object>;
    };
    static getName(): string;
    constructor(props: any);
    constructor(props: any, context: any);
    getStateFromProps(): {
        onChange: (formData: any) => void;
    };
    onChange: (formData: any) => void;
}
import * as React from "react";
import * as PropTypes from "prop-types";
