/**
 * Enables leaking any prop to any other prop container.
 *
 * uiSchema = {"ui:options": {
 *	props: [
 *		{
 *			from: If a regular string, a property to copy from formData. If a JSON pointer, the root will be this.props.
 *			target: Target where to copy the 'from'. If a regular string, it will be copied to /uischema/ui:options. If a JSON pointer, the root will be this.props.
 *		}
 */
export default class DataLeakerField extends React.Component<any, any, any> {
    static propTypes: {
        uiSchema: PropTypes.Validator<PropTypes.InferProps<{
            "ui:options": PropTypes.Requireable<PropTypes.InferProps<{
                props: PropTypes.Requireable<PropTypes.InferProps<{
                    from: PropTypes.Validator<string>;
                    fromArrayKey: PropTypes.Requireable<string>;
                    target: PropTypes.Requireable<string>;
                    joinArray: PropTypes.Requireable<boolean>;
                }> | (PropTypes.InferProps<{
                    from: PropTypes.Validator<string>;
                    fromArrayKey: PropTypes.Requireable<string>;
                    target: PropTypes.Requireable<string>;
                    joinArray: PropTypes.Requireable<boolean>;
                }> | null | undefined)[]>;
            }>>;
            uiSchema: PropTypes.Requireable<object>;
        }>>;
        schema: PropTypes.Validator<PropTypes.InferProps<{
            type: PropTypes.Requireable<string>;
        }>>;
        formData: PropTypes.Requireable<object>;
    };
    static getName(): string;
    constructor(props: any);
    constructor(props: any, context: any);
    getStateFromProps(props: any): any;
}
import * as React from "react";
import * as PropTypes from "prop-types";
