"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const immutability_helper_1 = require("immutability-helper");
const VirtualSchemaField_1 = require("../VirtualSchemaField");
/**
 * Sets given default values to target fields.
 * uiSchema = { "ui:options": {
 *  "default": [
 *    {
 *      field1: defaultValue1,
 *      field2: defaultValue2
 *    }
 *    ...
 *  ]
 * }}
 */
let DefaultValueArrayField = class DefaultValueArrayField extends React.Component {
    constructor() {
        super(...arguments);
        this.onChange = (formData) => {
            const options = this.getUiOptions();
            const _default = options.default;
            Object.keys(_default).forEach(field => {
                if (formData)
                    formData.forEach((item, i) => {
                        formData = immutability_helper_1.default(formData, { $splice: [[i, 1, immutability_helper_1.default(item, { $merge: { [field]: _default[field] } })]] });
                    });
            });
            this.props.onChange(formData);
        };
    }
    static getName() { return "DefaultValueArrayField"; }
    getStateFromProps() {
        return { onChange: this.onChange };
    }
};
DefaultValueArrayField.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            default: PropTypes.object.isRequired
        }).isRequired
    }).isRequired,
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["array"])
    }).isRequired,
    formData: PropTypes.oneOfType([PropTypes.array]).isRequired
};
DefaultValueArrayField = __decorate([
    VirtualSchemaField_1.default
], DefaultValueArrayField);
exports.default = DefaultValueArrayField;
