/**
 * Transforms an array field to o boolean field, where each value is true/false according to another array field.
 * Each value is true, if formData[booleanDefiner] == formData[booleanField].
 * uiSchema = { "ui:options": {
 *  booleanField: <array field name>,
 *  booleanDefiner: <array field name>,
 *  uiSchema: <uiSchema> (uiSchema used for each object).
 * }}
 */
export default class DependentBooleanField extends React.Component<any, any, any> {
    static propTypes: {
        uiSchema: PropTypes.Validator<PropTypes.InferProps<{
            "ui:options": PropTypes.Validator<PropTypes.InferProps<{
                booleanField: PropTypes.Validator<string>;
                booleanDefiner: PropTypes.Validator<string>;
            }>>;
            uiSchema: PropTypes.Requireable<object>;
        }>>;
        schema: PropTypes.Validator<PropTypes.InferProps<{
            type: PropTypes.Requireable<string>;
        }>>;
        formData: PropTypes.Validator<object>;
    };
    static getName(): string;
    constructor(props: any);
    constructor(props: any, context: any);
    getStateFromProps(props: any): {
        schema: any;
        uiSchema: any;
        formData: any;
        onChange: (formData: any) => void;
    };
    onChange: (formData: any) => void;
    getDictionarifiedFormData: (formData: any, field: any) => {};
    getDictionarifiedBooleanFieldData: (formData: any) => {};
}
import * as React from "react";
import * as PropTypes from "prop-types";
