/**
 * Disables object field's value according a regexp rule that is matched against another field's value.
 * uiSchema = { "ui:options": {
 *  disableField: <object field name>, (field to disable if disableDefiner's value doesn't match the regexp)
 *  disableDefiner: <object field name>, (field that the regexp is matched against)
 *  uiSchema: <uiSchema> (uiSchema used for each object).
 * }}
 */
export default class DependentDisableField extends React.Component<any, any, any> {
    static propTypes: {
        uiSchema: PropTypes.Validator<PropTypes.InferProps<{
            "ui:options": PropTypes.Requireable<PropTypes.InferProps<{
                rules: PropTypes.Validator<(PropTypes.InferProps<{
                    disableField: PropTypes.Validator<string>;
                    disableDefiner: PropTypes.Validator<string>;
                    regexp: PropTypes.Validator<string>;
                }> | null | undefined)[]>;
            }>>;
            uiSchema: PropTypes.Requireable<object>;
        }>>;
        schema: PropTypes.Validator<PropTypes.InferProps<{
            type: PropTypes.Requireable<string>;
        }>>;
        formData: PropTypes.Validator<object>;
    };
    static getName(): string;
    constructor(props: any);
    constructor(props: any, context: any);
    getStateFromProps(props: any): {
        uiSchema: any;
        formData: any;
    };
}
import * as React from "react";
import * as PropTypes from "prop-types";
