"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const react_dom_1 = require("react-dom");
const BaseComponent_1 = require("../BaseComponent");
const utils_1 = require("../../utils");
const AutosuggestWidget_1 = require("../widgets/AutosuggestWidget");
const TagArrayField_1 = require("./TagArrayField");
let EnumRangeArrayField = class EnumRangeArrayField extends React.Component {
    constructor(props) {
        super(props);
        this.setRef = (elem) => {
            this.autosuggestRef = elem;
        };
        this.onInputChange = ({ target: { value } }, reason, callback) => {
            this.setState({ value }, callback);
            if (reason === "click") {
                const tagComponent = this.autosuggestRef.autosuggestRef.inputElem;
                const tagComponentElem = react_dom_1.findDOMNode(tagComponent);
                const input = tagComponentElem.querySelector("input");
                if (input) {
                    input.focus();
                }
            }
            return value;
        };
        this.onSuggestionSelected = (suggestion) => {
            this.setState({ value: "" }, () => {
                this.onChange([...(this.props.formData || []), suggestion.value], "suggestion selected");
            });
        };
        this.onUnsuggestedSelected = (value) => {
            this.setState({ value: "" }, () => {
                this.onChange([...(this.props.formData || []), value], "unsuggested selected");
            });
        };
        this.onChange = (formData, reason) => {
            function onlyUnique(value, index, self) {
                return self.indexOf(value) === index;
            }
            formData = formData.filter(onlyUnique);
            if (reason !== "remove" && reason !== "suggestion selected" && reason !== "unsuggested selected") {
                this.setState({ value: "" });
                return;
            }
            this.setState({ value: "" }, () => {
                this.props.onChange(formData);
            });
        };
        this.state = { value: "" };
    }
    static getName() { return "EnumRangeArrayField"; }
    render() {
        const { range } = utils_1.getUiOptions(this.props.uiSchema);
        const autosuggestOptions = {
            autosuggestField: range,
            onSuggestionSelected: this.onSuggestionSelected,
            onConfirmUnsuggested: this.onConfirmUnsuggested,
            id: this.props.idSchema.$id,
            value: this.state.value,
            controlledValue: true,
            minFetchLength: 0,
            wrapperClassName: "laji-form-enum-range",
            inputProps: {
                value: this.state.value,
                that: this,
                InputComponent: EnumRangeInputInjection,
                onChange: this.onInputChange,
                tags: this.props.formData,
                id: this.props.idSchema.$id
            },
            allowNonsuggestedValue: false
        };
        const { Label } = this.props.formContext;
        return (React.createElement(React.Fragment, null,
            React.createElement(Label, { label: this.props.schema.title, id: this.props.idSchema.$id }),
            React.createElement(AutosuggestWidget_1.Autosuggest, Object.assign({}, this.props, { onChange: undefined }, autosuggestOptions, { ref: this.setRef }))));
    }
};
EnumRangeArrayField.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            range: PropTypes.string
        })
    }),
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["array"])
    }).isRequired,
    formData: PropTypes.array
};
EnumRangeArrayField = __decorate([
    BaseComponent_1.default
], EnumRangeArrayField);
exports.default = EnumRangeArrayField;
class EnumRangeInputInjection extends React.Component {
    constructor() {
        super(...arguments);
        this.onInputChange = e => {
            this.props.onChange(e);
        };
        this.onChange = (tags, reason) => {
            this.props.that.onChange(tags, reason);
        };
    }
    render() {
        return React.createElement(TagArrayField_1.TagInputComponent, Object.assign({}, this.props, { formContext: this.props.that.props.formContext, onChange: this.onChange, onInputChange: this.onInputChange }));
    }
}
