"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const utils_1 = require("../../utils");
const components_1 = require("../components");
const BaseComponent_1 = require("../BaseComponent");
const ReactContext_1 = require("../../ReactContext");
const utils_2 = require("@rjsf/utils");
let ExtraLabelRowField = class ExtraLabelRowField extends React.Component {
    constructor() {
        super(...arguments);
        this.setContainerRef = (elem) => {
            this.containerElem = elem;
        };
        this.getContainerRef = () => {
            return this.containerElem;
        };
        this.getColContent = (label, i) => {
            const cols = this.getCols(label.size);
            const { Label } = this.props.formContext;
            const { Col } = this.context.theme;
            return (React.createElement(Col, Object.assign({}, cols, { key: i }),
                React.createElement(Label, { label: label.label, id: this.props.idSchema.$id, uiSchema: { "ui:help": label.help } })));
        };
        this.getCols = (property) => {
            const cols = { lg: 12, md: 12, sm: 12, xs: 12 };
            const options = utils_1.getUiOptions(this.props.uiSchema);
            Object.keys(cols).forEach(col => {
                const optionCol = options[col];
                if (typeof optionCol === "object") {
                    let selector = undefined;
                    if (optionCol[property])
                        selector = property;
                    else if (optionCol["*"])
                        selector = "*";
                    cols[col] = optionCol[selector];
                }
                else {
                    cols[col] = optionCol;
                }
            });
            return cols;
        };
    }
    getStateFromProps(props) {
        return {
            schema: Object.assign(Object.assign({}, props.schema), { title: "" }),
            uiSchema: utils_1.getInnerUiSchema(props.uiSchema),
            options: utils_1.getUiOptions(props.uiSchema)
        };
    }
    render() {
        const { SchemaField } = this.props.registry.fields;
        const TitleFieldTemplate = utils_2.getTemplate("TitleFieldTemplate", this.props.registry, utils_1.getUiOptions(this.props.uiSchema));
        const { labels, hiddenXs, affixed } = utils_1.getUiOptions(this.props.uiSchema);
        const cols = [];
        labels.forEach((label, i) => {
            cols.push(this.getColContent(label, i));
        });
        const title = this.props.schema.title !== undefined ? this.props.schema.title : this.props.name;
        const { Row } = this.context.theme;
        let labelRow = React.createElement(Row, { className: "laji-form-label-row" + (hiddenXs ? " hidden-xs" : "") + (affixed ? " affixed-labels" : "") }, cols);
        if (affixed) {
            labelRow = (React.createElement(components_1.Affix, { getContainer: this.getContainerRef, style: affixed ? { position: "relative", zIndex: 1 } : undefined, topOffset: this.props.formContext.topOffset, bottomOffset: this.props.formContext.bottomOffset }, labelRow));
        }
        return (React.createElement("div", { ref: this.setContainerRef },
            title
                ? (React.createElement(TitleFieldTemplate, { title: title, schema: this.props.schema, uiSchema: this.props.uiSchema, id: this.props.idSchema.$id, registry: this.props.registry })) : null,
            labelRow,
            React.createElement(SchemaField, Object.assign({}, this.props, this.state))));
    }
};
ExtraLabelRowField.contextType = ReactContext_1.default;
ExtraLabelRowField.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            labels: PropTypes.arrayOf(PropTypes.object).isRequired,
            lg: PropTypes.oneOfType([PropTypes.number, PropTypes.object]),
            md: PropTypes.oneOfType([PropTypes.number, PropTypes.object]),
            sm: PropTypes.oneOfType([PropTypes.number, PropTypes.object]),
            xs: PropTypes.oneOfType([PropTypes.number, PropTypes.object]),
            hiddenXs: PropTypes.boolean
        })
    }).isRequired,
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["object", "array"])
    }).isRequired,
    formData: PropTypes.oneOfType([PropTypes.object, PropTypes.array]).isRequired
};
ExtraLabelRowField = __decorate([
    BaseComponent_1.default
], ExtraLabelRowField);
exports.default = ExtraLabelRowField;
