"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const utils_1 = require("../../utils");
const components_1 = require("../components");
const BaseComponent_1 = require("../BaseComponent");
const ReactContext_1 = require("../../ReactContext");
let InitiallyHiddenField = class InitiallyHiddenField extends React.Component {
    constructor(props) {
        super(props);
        this.toggleVisibility = () => {
            this.setState({ visible: !this.state.visible });
        };
        this.state = Object.assign({ visible: false }, this.getStateFromProps(props));
    }
    getStateFromProps(props) {
        return { uiSchema: utils_1.getInnerUiSchema(props.uiSchema) };
    }
    render() {
        let shouldShow = this.state.visible;
        const SchemaField = this.props.registry.fields.SchemaField;
        const { Row, Col, Collapse } = this.context.theme;
        return (React.createElement("div", null,
            React.createElement(Collapse, { in: !shouldShow },
                React.createElement(Row, null,
                    React.createElement(Col, { xs: 2, xsOffset: 10 },
                        React.createElement(components_1.Button, { className: "button-right", onClick: this.toggleVisibility },
                            this.props.schema.title || this.props.name,
                            " ",
                            React.createElement("span", { className: "caret" }))))),
            React.createElement(Collapse, { in: shouldShow },
                React.createElement("div", null,
                    React.createElement(SchemaField, Object.assign({}, this.props, this.state))))));
    }
};
InitiallyHiddenField.contextType = ReactContext_1.default;
InitiallyHiddenField.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            uiSchema: PropTypes.object
        })
    }).isRequired,
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["object", "array"])
    }).isRequired,
    formData: PropTypes.oneOfType([PropTypes.object, PropTypes.array]).isRequired
};
InitiallyHiddenField = __decorate([
    BaseComponent_1.default
], InitiallyHiddenField);
exports.default = InitiallyHiddenField;
