/**
 * Injects given fields value as default value to target field.
 * uiSchema = { "ui:options": {
 *  "injections": [
 *    {
 *      "fields": [field1, field2...], (fields to inject from source field)
 *      "target": fieldName (target field where default value is injected)
 *      "source": fieldName (source field where default value is injected from. Must be object field)
 *    }
 *    ...
 *  ]
 * }}
 */
export default class InjectDefaultValueField extends React.Component<any, any, any> {
    static propTypes: {
        uiSchema: PropTypes.Validator<PropTypes.InferProps<{
            "ui:options": PropTypes.Validator<PropTypes.InferProps<{
                fields: PropTypes.Validator<(string | null | undefined)[]>;
                target: PropTypes.Validator<string>;
                source: PropTypes.Validator<string>;
            }>>;
        }>>;
        schema: PropTypes.Validator<PropTypes.InferProps<{
            type: PropTypes.Requireable<string>;
        }>>;
        formData: PropTypes.Validator<object>;
    };
    static getName(): string;
    constructor(props: any);
    constructor(props: any, context: any);
    getStateFromProps(): {
        onChange: (formData: any) => void;
    };
    onChange: (formData: any) => void;
}
import * as React from "react";
import * as PropTypes from "prop-types";
