/**
 * Inject a schema object property to nested schema.
 * uiSchema = { "ui:options": {
 *  "injections": [
 *    {
 *      "fields": [field1, field2...],
 *      "target": fieldName
 *    }
 *    ...
 *  ]
 * }}
 */
export default class InjectField extends React.Component<any, any, any> {
    static propTypes: {
        uiSchema: PropTypes.Validator<PropTypes.InferProps<{
            "ui:options": PropTypes.Validator<PropTypes.InferProps<{
                injections: PropTypes.Validator<PropTypes.InferProps<{
                    fields: PropTypes.Validator<(string | null | undefined)[]>;
                    target: PropTypes.Validator<string>;
                }> | (PropTypes.InferProps<{
                    fields: PropTypes.Validator<(string | null | undefined)[]>;
                    target: PropTypes.Validator<string>;
                }> | null | undefined)[]>;
            }>>;
            uiSchema: PropTypes.Requireable<object>;
        }>>;
        schema: PropTypes.Validator<PropTypes.InferProps<{
            type: PropTypes.Requireable<string>;
        }>>;
        formData: PropTypes.Validator<object>;
    };
    static getName(): string;
    constructor(props: any);
    constructor(props: any, context: any);
    getStateFromProps(props: any): {
        schema: any;
        uiSchema: any;
        idSchema: any;
        formData: any;
        errorSchema: any;
        onChange: (formData: any) => void;
    };
    onChange: (formData: any) => void;
}
import * as React from "react";
import * as PropTypes from "prop-types";
