"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const utils_1 = require("../../utils");
const utils_2 = require("laji-map/lib/utils");
const ContextInjectionField_1 = require("./ContextInjectionField");
const utils_3 = require("@rjsf/utils");
const core_1 = require("@rjsf/core");
class _SchemaField extends React.Component {
    constructor(props) {
        super(props);
        this.updateVirtualInstance = (props, initial) => {
            const virtualizedProps = ["ui:functions", "ui:childFunctions", "ui:annotations", "ui:multiLanguage"];
            if ([props, this.props].some(_props => _props.uiSchema && virtualizedProps.some(prop => _props.uiSchema[prop])) &&
                (initial || !utils_3.deepEquals(this.props, props))) {
                this.functionOutputProps = this.applyFunction(props);
            }
        };
        this.updateVirtualInstance(props, !!"initial");
        this.state = { showAnnotations: false };
    }
    UNSAFE_componentWillReceiveProps(props) {
        this.updateVirtualInstance(props);
    }
    applyFunction(props) {
        let _a = (props.uiSchema || {}), { "ui:functions": functions, "ui:childFunctions": childFunctions, "ui:annotations": annotations, "ui:multiLanguage": multiLanguage } = _a, _uiSchema = __rest(_a, ["ui:functions", "ui:childFunctions", "ui:annotations", "ui:multiLanguage"]);
        const objectOrArrayAsArray = item => (item
            ? (Array.isArray(item)
                ? item
                : [item])
            : []);
        functions = objectOrArrayAsArray(functions);
        if (childFunctions) {
            functions = [
                { "ui:field": "UiFieldMapperArrayField", "ui:options": { functions: childFunctions } },
                ...functions
            ];
        }
        if (annotations) {
            functions = [
                { "ui:field": "AnnotationField", "ui:options": (utils_2.isObject(annotations) ? annotations : {}) },
                ...functions
            ];
        }
        if (multiLanguage) {
            functions = [
                { "ui:field": "MultiLanguageField" },
                ...functions
            ];
        }
        if (!functions.length)
            return props;
        let _props = Object.assign(Object.assign({}, props), { uiSchema: _uiSchema });
        let [uiFn, ...restUiFns] = functions;
        const { "ui:injections": injections } = uiFn;
        if (injections) {
            const injectedUiSchema = ContextInjectionField_1.getInjectedUiSchema(uiFn, injections, props.registry.formContext.uiSchemaContext);
            uiFn = Object.assign(Object.assign({}, injectedUiSchema), { "ui:injections": undefined });
        }
        const buttons = !_props.uiSchema["ui:field"] ? utils_1.getUiOptions(_props.uiSchema).buttons : undefined;
        const uiButtons = !_props.uiSchema["ui:field"] ? utils_1.getUiOptions(_props.uiSchema)["ui:buttons"] : undefined;
        _props = Object.assign(Object.assign({}, _props), { uiSchema: (_props.uiSchema["ui:field"] || _props.uiSchema["ui:widget"])
                ? Object.assign(Object.assign({}, uiFn), { uiSchema: _props.uiSchema }) : Object.assign(Object.assign({}, _props.uiSchema), uiFn) });
        if (buttons || uiButtons) {
            _props = Object.assign(Object.assign({}, _props), { uiSchema: Object.assign(Object.assign({}, _props.uiSchema), { "ui:options": Object.assign(Object.assign({}, _props.uiSchema["ui:options"]), { buttons: [...(_props.uiSchema.buttons || []), ...(buttons || [])], "ui:buttons": [...(_props.uiSchema["ui:buttons"] || []), ...(uiButtons || [])] }) }) });
        }
        return Object.assign(Object.assign({}, _props), { uiSchema: Object.assign(Object.assign({}, _props.uiSchema), { "ui:functions": restUiFns }) });
    }
    render() {
        const props = this.functionOutputProps || this.props;
        let { schema, uiSchema = {}, formContext, registry } = props, _props = __rest(props, ["schema", "uiSchema", "formContext", "registry"]); // eslint-disable-line @typescript-eslint/no-unused-vars
        const { formContext: _formContext } = registry;
        if (schema.uniqueItems && schema.items.enum && !utils_1.isMultiSelect(schema, uiSchema) && schema.uniqueItems) {
            schema = Object.assign(Object.assign({}, schema), { uniqueItems: false });
        }
        const options = utils_1.getUiOptions(uiSchema);
        if (typeof options.label === "string") {
            schema = Object.assign(Object.assign({}, schema), { title: options.label });
        }
        const { "ui:injections": injections } = uiSchema;
        if (injections) {
            const injectedUiSchema = ContextInjectionField_1.getInjectedUiSchema(uiSchema, injections, _formContext.uiSchemaContext);
            uiSchema = Object.assign(Object.assign({}, injectedUiSchema), { "ui:injections": undefined });
        }
        // Remove unnecessary formDataTransformers in order to prevent unnecessary rendering.
        if (_formContext && _formContext.formDataTransformers && _formContext.formDataTransformers.length) {
            const removeIdxs = /\d+_?/g;
            const idWithoutIdxs = this.props.idSchema.$id.replace(removeIdxs, "");
            const filtered = _formContext.formDataTransformers.filter(({ targets }) => targets.some(target => target.replace(removeIdxs, "").startsWith(idWithoutIdxs)));
            if (filtered.length !== _formContext.formDataTransformers.length) {
                registry = Object.assign(Object.assign({}, registry), { formContext: Object.assign(Object.assign({}, _formContext), { formDataTransformers: filtered }) });
            }
        }
        const { SchemaField } = core_1.getDefaultRegistry().fields;
        return React.createElement(SchemaField, Object.assign({}, _props, { registry: registry, schema: schema, uiSchema: uiSchema }));
    }
}
exports.default = _SchemaField;
