"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const VirtualSchemaField_1 = require("../VirtualSchemaField");
const utils_1 = require("../../utils");
const ArrayField_1 = require("./ArrayField");
let SingleItemArrayField = class SingleItemArrayField extends React.Component {
    constructor(props) {
        super(props);
        this.getActiveIdx = (props) => {
            const options = utils_1.getUiOptions(props.uiSchema);
            return "activeIdx" in options
                ? options.activeIdx
                : 0;
        };
        this.onChange = (formData) => {
            const activeIdx = this.getActiveIdx(this.props);
            const copy = (this.props.formData || []).slice();
            copy[activeIdx] = formData;
            this.props.onChange(copy);
        };
        props.formContext.globals[`${this.props.idSchema.$id}.activeIdx`] = this.getActiveIdx(props);
    }
    static getName() { return "SingleItemArrayField"; }
    componentDidUpdate() {
        this.props.formContext.globals[`${this.props.idSchema.$id}.activeIdx`] = this.getActiveIdx(this.props);
    }
    getStateFromProps(props) {
        const activeIdx = this.getActiveIdx(props);
        if (typeof activeIdx !== "number" || isNaN(activeIdx)) {
            return Object.assign(Object.assign({}, props), { uiSchema: {
                    "ui:field": "HiddenField"
                } });
        }
        let uiSchema = Object.assign(Object.assign({ "ui:title": utils_1.getTitle(props, activeIdx), "ui:help": props.uiSchema["ui:help"] }, props.uiSchema.items || {}), { "ui:options": Object.assign({ titleClassName: utils_1.getUiOptions(props.uiSchema).titleClassName }, utils_1.getUiOptions(props.uiSchema.items)) });
        if (utils_1.isMultiSelect(props.schema, uiSchema)) {
            uiSchema = Object.assign(Object.assign({}, uiSchema), { "ui:options": Object.assign(Object.assign({}, utils_1.getUiOptions(uiSchema)), { renderTitleAsLabel: true }) });
        }
        return Object.assign(Object.assign({}, props), { formData: props.formData && props.formData.length && activeIdx in props.formData
                ? props.formData[activeIdx]
                : utils_1.addLajiFormIds(utils_1.getDefaultFormState(props.schema.items), this.props.formContext.services.ids.getRelativeTmpIdTree(props.idSchema.$id), false)[0], schema: props.schema.items, uiSchema, idSchema: ArrayField_1.ArrayFieldPatched.prototype.getIdSchema.call(this, props, activeIdx), errorSchema: props.errorSchema[activeIdx] || {}, onChange: this.onChange });
    }
};
SingleItemArrayField.propTypes = {
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["array"])
    }).isRequired,
    formData: PropTypes.array
};
SingleItemArrayField = __decorate([
    VirtualSchemaField_1.default
], SingleItemArrayField);
exports.default = SingleItemArrayField;
