"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AnyToBoolean = void 0;
const React = require("react");
const PropTypes = require("prop-types");
const utils_1 = require("../../utils");
const AnyToBoolean = (props) => React.createElement(_AnyToBoolean, Object.assign({}, props));
exports.AnyToBoolean = AnyToBoolean;
const _AnyToBoolean = (props) => {
    const { widget } = props;
    const options = utils_1.getUiOptions(widget ? props : props.uiSchema);
    const { trueValue, falseValue, allowUndefined = true } = options;
    const schema = Object.assign(Object.assign({}, props.schema), { type: "boolean", title: allowUndefined ? "" : props.schema.title });
    const id = widget ? props.id : props.idSchema.$id;
    const value = props.formContext.utils.formDataEquals(props[widget ? "value" : "formData"], trueValue, id)
        ? true
        : props.formContext.utils.formDataEquals(props[widget ? "value" : "formData"], falseValue, id)
            ? false
            : undefined;
    const _onChange = props.onChange;
    const onChange = React.useCallback((value) => {
        const newValue = value === undefined
            ? undefined
            : value === true
                ? trueValue
                : falseValue;
        _onChange(newValue);
    }, [_onChange, trueValue, falseValue]);
    const { CheckboxWidget } = props.registry.widgets;
    const { SchemaField } = props.registry.fields;
    return widget
        ? (React.createElement(CheckboxWidget, Object.assign({}, props, { id: props.id, schema: schema, value: value, onChange: onChange, label: "", options: options }))) : (React.createElement(SchemaField, Object.assign({}, props, { schema: schema, uiSchema: utils_1.getInnerUiSchema(props.uiSchema), formData: value, onChange: onChange, label: "", options: options })));
};
const _anyToBoolean = (props) => React.createElement(_AnyToBoolean, Object.assign({ widget: true }, props));
const valuePropType = PropTypes.oneOfType([PropTypes.string, PropTypes.number, PropTypes.bool]);
_anyToBoolean.propTypes = {
    uiSchema: PropTypes.shape({
        "ui:options": PropTypes.shape({
            trueValue: valuePropType.isRequired,
            falseValue: valuePropType,
            allowUndefined: PropTypes.bool
        })
    }),
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["string", "number", "boolean"])
    }).isRequired,
    formData: valuePropType
};
exports.default = _anyToBoolean;
