"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
function HiddenWidget({ id, value }) {
    return (React.createElement("input", { type: "hidden", id: id, value: typeof value === "undefined" ? "" : value }));
}
HiddenWidget.propTypes = {
    id: PropTypes.string.isRequired,
    value: PropTypes.oneOfType([
        PropTypes.string,
        PropTypes.number,
        PropTypes.bool,
    ]),
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["string", "number", "boolean", "integer"])
    }).isRequired
};
exports.default = HiddenWidget;
