"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const utils_1 = require("../../utils");
function PlainTextWidget(props) {
    const { id, value } = props;
    const { strong, "ui:widget": formatterWidget, "ui:options": formatterOptions, centered, tag } = utils_1.getUiOptions(props);
    const formattedValue = utils_1.formatValue(Object.assign(Object.assign({}, props), { uiSchema: formatterWidget ? { "ui:widget": formatterWidget, options: formatterOptions } : props.uiSchema, schema: props.schema, formData: props.value }));
    const Tag = tag || "span";
    return (React.createElement(Tag, { className: `plainText${centered ? " horizontally-centered row-height" : ""}` },
        strong ? React.createElement("strong", null, formattedValue) : formattedValue,
        React.createElement("input", { type: "hidden", id: id, value: typeof value === "undefined" ? "" : value })));
}
if (process.env.NODE_ENV !== "production") {
    PlainTextWidget.propTypes = {
        id: PropTypes.string.isRequired,
        value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
        schema: PropTypes.shape({
            type: PropTypes.oneOf(["string", "number", "integer"])
        })
    };
}
exports.default = PlainTextWidget;
