"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const PropTypes = require("prop-types");
const DateWidget_1 = require("./DateWidget");
const TimeWidget_1 = require("./TimeWidget");
const BaseComponent_1 = require("../BaseComponent");
const ReactContext_1 = require("../../ReactContext");
let SeparatedDateTimeWidget = class SeparatedDateTimeWidget extends React.Component {
    constructor() {
        super(...arguments);
        this.onDateChange = (value) => {
            this.props.onChange(value ? (this.state.time ? value + this.state.time : value) : null);
        };
        this.onTimeChange = (value) => {
            this.props.onChange(value ? this.state.date + value : this.state.date);
        };
    }
    getStateFromProps(props) {
        let { value } = props;
        let date, time;
        if (value) {
            let splitted = value.split("T");
            if (splitted.length == 2) {
                time = "T" + splitted[1];
            }
            date = splitted[0];
        }
        return { date, time };
    }
    render() {
        const hasDate = !!this.state.date;
        const { Row, Col, FormGroup } = this.context.theme;
        return (React.createElement(Row, null,
            React.createElement(Col, { lg: hasDate ? 6 : 12 },
                React.createElement(FormGroup, null,
                    React.createElement(DateWidget_1.default, Object.assign({}, this.props, { onChange: this.onDateChange, value: this.state.date })))),
            hasDate ? (React.createElement(Col, { lg: 6 },
                React.createElement(FormGroup, null,
                    React.createElement(TimeWidget_1.default, Object.assign({}, this.props, { onChange: this.onTimeChange, value: this.state.time }))))) : null));
    }
};
SeparatedDateTimeWidget.contextType = ReactContext_1.default;
SeparatedDateTimeWidget.propTypes = {
    schema: PropTypes.shape({
        type: PropTypes.oneOf(["string"])
    }).isRequired,
    value: PropTypes.string
};
SeparatedDateTimeWidget = __decorate([
    BaseComponent_1.default
], SeparatedDateTimeWidget);
exports.default = SeparatedDateTimeWidget;
