import { FieldProps, WidgetProps } from "../components/LajiForm";
export interface SubmitHook {
    hook: () => void;
    promise: Promise<any>;
    lajiFormId: string;
    relativePointer: string | undefined;
    running: boolean;
    description?: string;
    failed?: boolean;
}
export default class SubmitHookService {
    private onSubmitHooksChange;
    private submitHooks;
    constructor(onSubmitHooksChange: (submitHooks: SubmitHook[]) => void);
    private send;
    private internalAdd;
    /**
     * Add a submit hook for a Field component.
     */
    add(props: Pick<FieldProps, "formData" | "idSchema" | "formContext"> | Pick<WidgetProps, "formData" | "id" | "formContext">, hook: SubmitHook["hook"]): () => Promise<any>;
    remove(lajiFormId: string, hook: SubmitHook["hook"]): Promise<void>;
    removeAll(): void;
    checkHooks(): Promise<void[]>;
}
