"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const test_utils_1 = require("./test-utils");
describe("Collection contest form (MHL.25)", () => {
    let form;
    describe("Without data", () => {
        beforeAll(() => __awaiter(void 0, void 0, void 0, function* () {
            form = yield test_utils_1.createForm({ id: "MHL.25" });
        }));
        it("adds observation", () => __awaiter(void 0, void 0, void 0, function* () {
            yield form.$locateButton("gatherings", "add").click();
        }));
        it("shows gathering date and hides unit date", () => __awaiter(void 0, void 0, void 0, function* () {
            expect(yield form.$locate("gatherings.0.dateBegin").isDisplayed()).toBe(true);
            expect(yield form.$locate("gatherings.0.units.0.unitGathering.dateBegin").isPresent()).toBe(false);
        }));
        describe("injected date field", () => {
            let dateWidget;
            it("is date widget", () => __awaiter(void 0, void 0, void 0, function* () {
                dateWidget = form.getDateWidget("gatherings.0.dateBegin");
                expect(yield dateWidget.$input.isDisplayed()).toBe(true);
            }));
            it("onChange works", () => __awaiter(void 0, void 0, void 0, function* () {
                yield dateWidget.buttons.$today.click();
                expect((yield dateWidget.$input.getAttribute("value")).length).not.toBe(0);
            }));
        });
    });
});
